/********************************** (C) COPYRIGHT *******************************
* File Name          : KEY_LED.C
* Author             : MJX
* Version            : V1.00
* Date               : 2021/04/29
* Description        : ɨ輰LEDغ
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include "MAIN.H"	 															/* ͷļ */
#include "KB_TAB.H"	 															/* USB */

/******************************************************************************/
/*  */
UINT8I  Time1_Count = 0x00;       									      		/* ʱ1ֵ */

UINT8   LED_COMMON_Start = 0x10;   												/* LED_COMMONʼֵ(COM16) */
UINT8   KEY_COMMON_Start = 0x10;   												/* ɨʼ(COM16) */

UINT8D  RGB_Mode = 0x00;               											/* RGBЧģʽ */
UINT8I  RGB_Stauts = 0x00;          											/* RGBɫת״̬ */
UINT8I  RGB_Load_Mode = 0x00;													/* RGBװģʽ: 0: XRAM, 1: FLASH  */
signed char data RGB_Incre = 0x00;

UINT16D	RGB_BufAddr;															/* RGBݻַ */
UINT8X	RGB_DataBuf0[ 144 ][ 4 ]    _at_ 0x0000;      							/* RGBݻ0 */
UINT8X	RGB_DataBuf1[ 144 ][ 4 ]    _at_ 0x0300;  								/* RGBݻ1 */
UINT8X	RGB_OffsetSave[ 144 ];  												/* RGBƫݴݻ */

KB_SCAN KB;																		/* ɨؽṹ */
UINT8X KB_Analy_Buf[ 8 ];				  										/* ̷ */
volatile UINT8  KB_Up_Buf[ 8 ];				  									/* ϴ */
volatile UINT8  KB_Press_LastCount = 0x00;				  						/* 1ΰ¸ */
volatile UINT8  KB_NonFun_Press_LastCount = 0x00;				  				/* 1ΰ·ǹܼ */
volatile UINT8  KB_USB_UpStatus = 0x00;											/* USBϴ״̬ */
volatile UINT8  KB_USB_SetReport = 0x00;										/* SetReportֵ */

/*******************************************************************************
* Function Name  : CH55X_Timer1_ModSetup
* Description    : CH55X ʱ1ģʽ
                   0ģʽ0, 13λʱ,TL1ĸ3λЧ
                   1ģʽ1, 16λʱ
                   2ģʽ2, 8λԶװʱ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void CH55X_Timer1_ModeSet( UINT8 mode )
{
	TMOD &= 0x0f;
	TMOD |= mode << 4; 
}

/*******************************************************************************
* Function Name  : CH55X_Timer1_DataSet
* Description    : CH55X ʱ1ֵ(TH1TL1)
* Input          : dat: ʱֵ
* Output         : None
* Return         : None
*******************************************************************************/
void CH55X_Timer1_DataSet( UINT16 dat )
{
	UINT16 tmp;
  
	tmp = 65536 - dat;
	TL1 = tmp & 0xff;
	TH1 = ( tmp >> 8 ) & 0xff;
}

/*******************************************************************************
* Function Name  : CH55X_Timer1_Init
* Description    : CH55X ʱ1ʼ
*				   ԼЧʱ	  
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH55X_Timer1_Init( void )
{
	/* ʱѡFsysʱʽ */
	mTimer1Clk12DivFsys( );                                                    
	CH55X_Timer1_ModeSet( 1 );	                                                                                                     
	CH55X_Timer1_DataSet( 0x9C40 );                                                    
	mTimer1RunCTL( 1 );                                                          
	ET1 = 1;                                                                   
}

/*******************************************************************************
* Function Name  : CH55X_Timer1_Interrupt
* Description    : CH55X ʱ1жϷ  
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH55X_Timer1_Interrupt( void ) interrupt INT_NO_TMR1               
{    
	/* öʱֵ */
	TL1 = ( 65536 - 0x9C40 ) & 0xFF;
	TH1 = ( ( 65536 - 0x9C40 ) >> 8 ) & 0xFF;	
	
	/* ʱش */	
	Time1_Count++;
	switch( RGB_Mode )
	{
        case DEF_RGB_MODE0:
            RGB_BufAddr = (UINT16)( &RGB_DataBuf0[ 0 ] );            
			if( RGB_Incre >= 127 )  
			{
				RGB_Stauts = 1;
            }
			if( RGB_Incre <= -127 ) 
			{
				RGB_Stauts = 0;
            }
            LED_GRE_ADJ = RGB_Stauts ? ( RGB_Incre-- ) : ( RGB_Incre++ );                  
	        break;

        case DEF_RGB_MODE1:
			RGB_BufAddr = (UINT16)( &RGB_DataBuf0[ 0 ] );            
	        break;
	        
        case DEF_RGB_MODE2:
            RGB_BufAddr = (UINT16)( &RGB_DataBuf1[ 0 ] );
	        break;

        case DEF_RGB_MODE3:
			if( Time1_Count >= 127 ) 
			{
				RGB_Stauts = 1;
			}
			if( Time1_Count < 127 ) 
			{
				RGB_Stauts = 0;
			}
			RGB_BufAddr = RGB_Stauts ? (UINT16)( &RGB_DataBuf1[ 0 ] ) : (UINT16)( &RGB_DataBuf0[ 0 ] );
        	break;
        	
		case DEF_RGB_MODE4:
			RGB_BufAddr =(UINT16)( &RGB_DataBuf1[ 0 ] );           
			break;
			
        default:
            RGB_Mode = 0;
            break;
	}  
} 

/*******************************************************************************
* Function Name  : CH55X_RGB_Init
* Description    : CH55XRGB LEDƳʼ  
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH55X_RGB_Init( void )
{ 
#if ( DEF_LED_LINE_SET == 16 )
	/* LEDɨ趨(ɨCOM16-COM31Ϊ16 ) */
	LED_COMMON_Start = 0x10;   												
#endif

#if ( DEF_LED_LINE_SET == 18 )
	/* LEDɨ趨(ɨCOM14-COM3118 ) */
	LED_COMMON_Start = 0x0E;  
	P7 |= ( bP7_1_DIR | bP7_0_DIR ); 	
	P7 |= 0x03; 	 												
#endif

#if ( DEF_KEY_LINE_SET == 16 )
	/* ɨ趨(ɨCOM16-COM31Ϊ16 ) */
	KEY_COMMON_Start = 0x10; 
	KB.Scan_Line = 0xFF;  												
#endif

#if ( DEF_KEY_LINE_SET == 18 )
	/* ɨ趨(ɨCOM14-COM3118 ) */
	KEY_COMMON_Start = 0x0E;
	KB.Scan_Line = 0xFF;   												
#endif
	
	/* ʼر */
	RGB_Mode = 0x02;               											
	RGB_Stauts = 0x00;          											
	RGB_Load_Mode = 0x00;												
	RGB_Incre = 0x00;

	/* LEDسʼ */
	P4 = P2 = P1 = 0xFF;  														/* R/G/B PWM pins invert output, low action for sink current */
	P0 = P3 = 0xFF;  															/* COMMON pin invert output, low action for drive external PMOS */
	P4_MOD_OC = P2_MOD_OC = P1_MOD_OC = 0;  									/* R/G/B PWM pins push-pull output */
	P0_MOD_OC = P3_MOD_OC = 0;  												/* COMMON pins push-pull output */
	LED_CTRL = bLED_EN;
	LED_CYCLE = bLED_INTEN_CYC0; 												/* PWM_128@color,PWM_128@intenisy,1x bLED_COLOR_CYC|  MASK_LED_INT_CYC */
	LED_FRAME = bLED_INH_TMR2 | bLED_INH_TMR0;  								/* 101->8 intenisy PWM cycles, same PWM data repeat 1 time */
	LED_DMA = RGB_BufAddr = (UINT16)( &RGB_DataBuf0[ 0 ] );  					/* buffer start address  */
	RGB_Load_Mode = 0;           												/* indicate data@xRAM (1=data@flash ROM) */
	LED_INT_ADJ = 0x00;  														/* adjust: increase intenisy */
	LED_PWM_OE = 0xFE;
	LED_COMMON = 0xFF;  														/* preset COMMON selection, next is 0, start @interrupt */
	LED_CTRL = bLED_IE_INHIB | bLED_BLUE_EN | bLED_GREEN_EN | bLED_RED_EN | bLED_COM_AHEAD | bLED_PWM_INHIB | bLED_EN;
	LED_STATUS |= bLED_IF_SET;  												/* force bLED_IF to enter interrupt service */ 
	IE_PWM_I2C = 1;

    LED_RED_ADJ = 0;
    LED_GRE_ADJ = 0;
    LED_BLU_ADJ = 0;

	/* RGB LEDжȼΪȼ */
//	IP_EX |= bIP_PWM_I2C;
}

/*******************************************************************************
* Function Name  : CH55X_RGB_ShowLogo
* Description    : CH55XRGB LEDʾLOGO
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH55X_RGB_ShowLogo( void )
{
    UINT8 i;
    
	for( i = 0; i < 144; i++ )
	{
		RGB_DataBuf0[ i ][ 0 ] = 127;
        RGB_DataBuf0[ i ][ 1 ] = 127;											/* R */
        RGB_DataBuf0[ i ][ 2 ] = 127;											/* G */
        RGB_DataBuf0[ i ][ 3 ] = 127;											/* B */
    }
	for( i = 0; i < 144; i++ )
	{
        RGB_DataBuf1[ i ][ 0 ] = 0;
        RGB_DataBuf1[ i ][ 1 ] = 0;												/* R */
        RGB_DataBuf1[ i ][ 2 ] = 0;												/* G */
        RGB_DataBuf1[ i ][ 3 ] = 0;												/* B */
    } 

	mDelaymS( 200 );
    RGB_BufAddr = (UINT16)( &RGB_DataBuf1[ 0 ] );  
    mDelaymS( 200 );
    RGB_BufAddr = (UINT16)( &RGB_DataBuf0[ 0 ] ); 
    mDelaymS( 200 ); 
    RGB_BufAddr = (UINT16)( &RGB_DataBuf1[ 0 ] );  
    mDelaymS( 200 );  
    RGB_BufAddr = (UINT16)( &RGB_DataBuf0[ 0 ] ); 
    mDelaymS( 200 ); 
    RGB_BufAddr = (UINT16)( &RGB_DataBuf1[ 0 ] );  
    mDelaymS( 200 ); 
}

/*******************************************************************************
* Function Name  : KB_Param_Init
* Description    : زʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void KB_Param_Init( void )
{
	memset( &KB.Scan_Line, 0xFF, sizeof( KB_SCAN ) );
	KB.Scan_Line = 0x00;														
	KB.Scan_LoadPtr = 0x00;													
	KB.Scan_DealPtr = 0x00;														
	KB.Scan_ReamLen = 0x00;									

	memset( KB_Up_Buf, 0x00, 8 );
	memset( KB_Analy_Buf, 0x00, 8 );
	KB_Press_LastCount = 0x00;
    KB_NonFun_Press_LastCount = 0x00;
}

/*******************************************************************************
* Function Name  : KB_Port_RD_Delay
* Description    : ̶˿ڶȡʱ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void KB_Port_RD_Delay( void )
{
	_nop_( ); _nop_( ); _nop_( ); _nop_( ); _nop_( );	
	_nop_( ); _nop_( ); _nop_( ); _nop_( ); _nop_( );		
}

/*******************************************************************************
* Function Name  : CH55X_Timer1_DataSet
* Description    : CH55X ʱ1ֵ(TH1TL1)
* Input          : dat: ʱֵ
* Output         : None
* Return         : None
*******************************************************************************/
void LED_INT( void ) interrupt INT_NO_PWM_I2C using 1	
{
	UINT8 idata com_save;
	UINT8 idata offset;

	/* лCOMLED */
	LED_COMMON++;
	if( ( LED_COMMON & 0x1F ) == 0x00 )	 
	{	
		/* switch COMMON, clear interrupt flag */      
		LED_COMMON = LED_COMMON_Start;	

		/* reset buffer start address */
		LED_DMA = RGB_BufAddr;		
	}
	if( RGB_Load_Mode ) 
	{
		/* load data from code ROM, and prepare COMMON pin low for key scan, ASM for speed */
		LED_LOAD_CODE( );	
	}
	else 
	{
		/* load data from XRAM, and prepare COMMON pin low for key scan, ASM for speed */
		LED_LOAD_XRAM( );	
    }

	/* ݴLED_COMMON */
	com_save = LED_COMMON;

	/* رLED,ʼɨ */	   
	P4_LED_KEY = 0xFF;															/* enable key mode */
	P4_MOD_OC = 0xFF;															/* disable push-pull output */
	_nop_( );																	/* delay at least 500nS for key input stable */
	_nop_( );
	ACC = LED_CTRL;																/* delay, and use DPTR to force PUSH DPTR (because LED_LOAD_* use DPTR) */	

//	PIN_DEBUG &= ~(1<<0);

	/*********************************************/
	/* ɨһа */
	KB.Scan_Line++;
	if( ( KB.Scan_Line & 0x1F ) == 0x00 )	
	{	    
		/* ɨһ */	 
		KB.Scan_Line = KEY_COMMON_Start;
			
		KB.Scan_LoadPtr++;	
		if( KB.Scan_LoadPtr >= DEF_SCAN_BUFNUM_MAX )		
		{
			KB.Scan_LoadPtr = 0x00;			
		}
		KB.Scan_ReamLen++;				
	}	 
	LED_COMMON = KB.Scan_Line;	
	LED_COM_KEY_L( );															/* ʹܵǰаɨ */
	KB_Port_RD_Delay( );
	offset = ( KB.Scan_Line & 0x1F ) - 0x0E;	
	KB.Scan_Status[ KB.Scan_LoadPtr ][ offset ] = P4;
	LED_COM_KEY_H( );															/* ǰаɨ */

	/*********************************************/
	/* ɨһа */
	KB.Scan_Line++;
	if( ( KB.Scan_Line & 0x1F ) == 0x00 )
	{	     
		/* ɨһ */	 
		KB.Scan_Line = KEY_COMMON_Start;
			
		KB.Scan_LoadPtr++;	
		if( KB.Scan_LoadPtr >= DEF_SCAN_BUFNUM_MAX )		
		{
			KB.Scan_LoadPtr = 0x00;			
		}
		KB.Scan_ReamLen++;				
	}	 
	LED_COMMON = KB.Scan_Line;	
	LED_COM_KEY_L( );															/* ʹܵǰаɨ */
	KB_Port_RD_Delay( );	
	offset = ( KB.Scan_Line & 0x1F ) - 0x0E;	
	KB.Scan_Status[ KB.Scan_LoadPtr ][ offset ] = P4;
	LED_COM_KEY_H( );															/* ǰаɨ */

	/*********************************************/
	/* ɨһа */
	KB.Scan_Line++;
	if( ( KB.Scan_Line & 0x1F ) == 0x00 )  
	{	  
		/* ɨһ */	 
		KB.Scan_Line = KEY_COMMON_Start;
			
		KB.Scan_LoadPtr++;	
		if( KB.Scan_LoadPtr >= DEF_SCAN_BUFNUM_MAX )		
		{
			KB.Scan_LoadPtr = 0x00;			
		}
		KB.Scan_ReamLen++;				
	}	 
	LED_COMMON = KB.Scan_Line;	
	LED_COM_KEY_L( );															/* ʹܵǰаɨ */
	KB_Port_RD_Delay( );	
	offset = ( KB.Scan_Line & 0x1F ) - 0x0E;	
	KB.Scan_Status[ KB.Scan_LoadPtr ][ offset ] = P4;
	LED_COM_KEY_H( );															/* ǰаɨ */

	/*********************************************/
	/* ɨһа */
	KB.Scan_Line++;
	if( ( KB.Scan_Line & 0x1F ) == 0x00 ) 
	{	     
		/* ɨһ */	 
		KB.Scan_Line = KEY_COMMON_Start;
			
		KB.Scan_LoadPtr++;	
		if( KB.Scan_LoadPtr >= DEF_SCAN_BUFNUM_MAX )		
		{
			KB.Scan_LoadPtr = 0x00;			
		}
		KB.Scan_ReamLen++;				
	}	 
	LED_COMMON = KB.Scan_Line;	
	LED_COM_KEY_L( );															/* ʹܵǰаɨ */
	KB_Port_RD_Delay( );	
	offset = ( KB.Scan_Line & 0x1F ) - 0x0E;	
	KB.Scan_Status[ KB.Scan_LoadPtr ][ offset ] = P4;
	LED_COM_KEY_H( );															/* ǰаɨ */

	/* ָLED_COMMON */
	LED_COMMON = com_save;	

//	PIN_DEBUG |= (1<<0);

	/* лLEDģʽ */
	P4_MOD_OC = 0;																/* push-pull output for PWM */
	P4_LED_KEY = 0;																/* disable key mode */
	LED_PWM_OE = 0xFF;															/* enable PWM output */
	P0 = P3 = 0xFF;  															/* COMMON pin invert output */
}

/*******************************************************************************
* Function Name  : KB_USB_DataUp
* Description    : USBݰϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void KB_USB_DataUp( UINT8 *pbuf, UINT8 len )
{  
	/* жϼǷ˯ģʽ,Ȼ */
	if( USB_SleepStatus == 0x03 )
	{
		USB_WakeUp_PC( );
	}

	/* ȴϴɣͬʱд */
	while( ( D0_EP1RES & MASK_UEP_X_RES ) == UEP_X_RES_ACK );                  
	
	/* װݲϴ */
	memcpy( pUSB_BUF_DEV0 + UX_EP1_ADDR, pbuf, len );
	D0_EP1RES ^= bUEP_X_TOG;	
	D0_EP1T_L = len;                                       
	D0_EP1RES = D0_EP1RES & ~MASK_UEP_X_RES | UEP_X_RES_ACK;               
}

/*******************************************************************************
* Function Name  : KB_Scan_Deal
* Description    : ɨ账
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 KB_Scan_Deal( void )
{		   
	UINT8  i, j;
	UINT8  dat;
	UINT8  value;
	UINT8  offset;
	UINT8  count;
    UINT8  fun_count;
	UINT8  dealptr;

	/* жǷﵽ趨ɨ */
	if( KB.Scan_ReamLen < DEF_SCAN_TIME_MAX )
	{
		return( 0x01 );
	}	

	/* Ƚɨ軺Ƿͬ */
	for( j = 0; j < DEF_SCAN_LINE_MAX; j++ )
	{		
		for( i = ( KB.Scan_DealPtr + 1 ); i < ( KB.Scan_DealPtr + DEF_SCAN_TIME_MAX ); i++ )
		{
			if( KB.Scan_Status[ KB.Scan_DealPtr ][ j ] != KB.Scan_Status[ i ][ j ] )
			{
				goto DATA_CMP_END;
			}					
		}		
	}
DATA_CMP_END:

	/* ر */
	dealptr = KB.Scan_DealPtr;
	KB.Scan_DealPtr += DEF_SCAN_TIME_MAX;
	if( KB.Scan_DealPtr >= DEF_SCAN_BUFNUM_MAX )
	{
		KB.Scan_DealPtr = 0x00;	
	}
	KB.Scan_ReamLen -= DEF_SCAN_TIME_MAX;

	/* ɨͬд, */
	if( j == DEF_SCAN_LINE_MAX )
	{       
        /* ת */
		offset = 0x00;
		count = 0x00;
        fun_count = 0x00;
		memset( KB_Analy_Buf, 0x00, 8 );
		for( j = 0; j < DEF_SCAN_LINE_MAX; j++ )
		{		
			if( KB.Scan_Status[ dealptr ][ j ] != 0xFF )
			{
				/* жϵǰаµλ */
				dat = KB.Scan_Status[ dealptr ][ j ];
				for( i = 0; i < 8; i++ )
				{
					if( ( dat & 0x01 ) == 0x00 )
					{
						value = ( 8 * j ) + i;
						RGB_OffsetSave[ count ] = value;							

						/* ܼ */
						if( value == 0x14 )			           
						{
							/* SIHFT-L */
							KB_Analy_Buf[ 0 ] |= KB_Tab[ value ];
                            fun_count++;
                            count++;
						}
						else if( value == 0x15 )
						{
							/* CTRL-L */
							KB_Analy_Buf[ 0 ] |= KB_Tab[ value ];
                            fun_count++;
                            count++;
						}
						else if( value == 0x1D )
						{
							/* WIN-L */
							KB_Analy_Buf[ 0 ] |= KB_Tab[ value ];
                            fun_count++;
                            count++;
						}
						else if( value == 0x25 )
						{
							/* ALT-L */
							KB_Analy_Buf[ 0 ] |= KB_Tab[ value ];
                            fun_count++;
                            count++;
						}
						else if( value == 0x35 )
						{
							/* ALT-R */
							KB_Analy_Buf[  0 ] |= KB_Tab[ value ];
                            fun_count++;
                            count++;
						}
						else if( value == 0x3D )
						{
							/* WIN-R */
							KB_Analy_Buf[ 0 ] |= KB_Tab[ value ];
                            fun_count++;
                            count++;
						}
						else if( value == 0x4D )
						{
							/* CTRL-R */
							KB_Analy_Buf[ 0 ] |= KB_Tab[ value ];
                            fun_count++;
                            count++;
						}
						else if( value == 0x6C )
						{
							/* SHIFT-R */
							KB_Analy_Buf[ 0 ] |= KB_Tab[ value ];
                            fun_count++;
                            count++;
						}
						else 
						{  
                            if( offset < 6 )
							{
								KB_Analy_Buf[ 2 + offset ] = KB_Tab[ value ];		               
								offset++;
								count++;
							}							
							if( offset >= 6 )
							{
								goto USB_DATA_UP;	
							}					
						}		
					}		
					dat = dat >> 1;								
				}
			}
		}

		/* USBϴ */
USB_DATA_UP:
		if( count )		
		{
            /* ǰаδͷ */
            
			/* жϵǰǰ»ͷ */
			if( count > KB_Press_LastCount )
			{		
                /* ° */
				offset = KB_NonFun_Press_LastCount;
                              
				for( j = 2; j < 8; j++ )
				{
					for( i = 2; i < 8; i++ )
					{
						if( KB_Analy_Buf[ j ] == KB_Up_Buf[ i ] )
						{
							break;
						}	
					}		
					if( i == 8 )
					{
						KB_Up_Buf[ 2 + offset ] = KB_Analy_Buf[ j ];
						offset++;	
					}			
				}	
				
				/* аϴ */
				KB_Up_Buf[ 0 ] = KB_Analy_Buf[ 0 ];
				KB_USB_DataUp( KB_Up_Buf, 8 );	
				
				/* ǷлЧȼ(ǰʹCTRL+F12л) */
				if( ( KB_Up_Buf[ 0 ] == 0x01 ) && ( KB_Up_Buf[ 2 ] == 0x45 ) )
				{
	                RGB_Mode++;
					if( RGB_Mode > 5 ) 
					{
						RGB_Mode = 0;
	                }
					LED_GRE_ADJ = 0; 
	            }													
			}			
			else if( count < KB_Press_LastCount )
			{
				/* оɰͷ */
				for( j = 2; j < 8; j++ )
				{
					for( i = 2; i < 8; i++ )
					{
						if( KB_Up_Buf[ j ] == KB_Analy_Buf[ i ] )
						{
							break;
						}	
					}		
					if( i == 8 )
					{
						KB_Up_Buf[ j ] = 0x00;

						/* ԰ */
						if( j < 7 )
						{
							memcpy( &KB_Up_Buf[ j ], &KB_Up_Buf[ j + 1 ], ( 8 - j - 1 ) );
							KB_Up_Buf[ 7 ] = 0x00;	
						}
					}			
				}

				/* аϴ */
				KB_Up_Buf[ 0 ] = KB_Analy_Buf[ 0 ];
				KB_USB_DataUp( KB_Up_Buf, 8 );
			}
			KB_Press_LastCount = count;
            KB_NonFun_Press_LastCount = KB_Press_LastCount - fun_count; 

			/* ǰRGBģʽΪ,ҪЧ */
	        if( RGB_Mode == 4 )
			{         
                srand( TL1 );
	            
#if ( DEF_LED_LINE_SET == 16 )
                for( i = 0; i < count; i++ )
				{
	                RGB_DataBuf1[ RGB_OffsetSave[ i ] - 0x10 ][ 0 ] = 220;
	                RGB_DataBuf1[ RGB_OffsetSave[ i ] - 0x10 ][ 1 ] = rand( ) % 256;
	                RGB_DataBuf1[ RGB_OffsetSave[ i ] - 0x10 ][ 2 ] = rand( ) % 256;
	                RGB_DataBuf1[ RGB_OffsetSave[ i ] - 0x10 ][ 3 ] = rand( ) % 256;
				}
#endif 

#if ( DEF_LED_LINE_SET == 18 )
                for( i = 0; i < count; i++ )
				{
	                RGB_DataBuf1[ RGB_OffsetSave[ i ] ][ 0 ] = 220;
	                RGB_DataBuf1[ RGB_OffsetSave[ i ] ][ 1 ] = rand( ) % 256;
	                RGB_DataBuf1[ RGB_OffsetSave[ i ] ][ 2 ] = rand( ) % 256;
	                RGB_DataBuf1[ RGB_OffsetSave[ i ] ][ 3 ] = rand( ) % 256;
				}
#endif                 
                
			}
		}
		else
		{           
            /* ǰް */
 			i = memcmp( KB_Up_Buf, KB_Analy_Buf, 8 );
			if( i )
			{				
				memcpy( KB_Up_Buf, KB_Analy_Buf, 8 );
				KB_USB_DataUp( KB_Up_Buf, 8 );	             
			}
			KB_Press_LastCount = 0x00;
            KB_NonFun_Press_LastCount = 0x00;

			/* ǰRGBģʽΪ,ҪЧ */
	        if( RGB_Mode == 4 )
			{
	            for( i = 0; i < 144; i++ )
				{
	                RGB_DataBuf1[ i ][ 0 ] = 0;
	                RGB_DataBuf1[ i ][ 1 ] = 0;
	                RGB_DataBuf1[ i ][ 2 ] = 0;
	                RGB_DataBuf1[ i ][ 3 ] = 0;
				}
			}
		}
		return( 0x00 );
	}
	return( 0x02 );
}

