/******************** (C) COPYRIGHT 2013 MJX ***********************************
* File Name          : USB_DESC.H
* Author             : MJX
* Version            : V1.00
* Date               : 2021/04/29
* Description        : USB豸
*******************************************************************************/


#ifndef __USB_DESC_H__
#define __USB_DESC_H__

#ifdef __cplusplus
extern "C" {
#endif


/******************************************************************************/
/* ͷļ */
#include "MAIN.H"	 															/* ͷļ */
#include "USB_DEVICE.H"															/* USB豸ͷļ */

/******************************************************************************/
/* USB豸 */
UINT8X MyDevice_DevDesc[ ] = 
{ 
	0x12,                       												/* bLength */
	0x01, 																		/* bDescriptorType */
	0x00,                       												/* bcdUSB */
	0x02,
	0x00,                       												/* bDeviceClass */
	0x00,                       												/* bDeviceSubClass */
	0x00,                       												/* bDeviceProtocol */
	0x08,                       												/* bMaxPacketSize */
	0x86,	        															/* idVendor*/
	0x1A,
	0xE5,     	                  												/* idProduct */
	0xE7,
	0x00,                       												/* bcdDevice rel. 2.00 */
	DEF_PROGRAM_VER,
	0x00,                          												/* Index of string descriptor describing manufacturer */
	0x00,                          												/* Index of string descriptor describing product */
	0x00,                          												/* Index of string descriptor describing the device serial number */
	0x01                        												/* bNumConfigurations */
};

/******************************************************************************/
/* USBͨHID */
UINT8C MyDevice_KB_RP_Desc[ ] =
{
    0x05,0x01,0x09,0x06,0xA1,0x01,0x05,0x07,
    0x19,0xe0,0x29,0xe7,0x15,0x00,0x25,0x01,
    0x75,0x01,0x95,0x08,0x81,0x02,0x95,0x01,
    0x75,0x08,0x81,0x01,0x95,0x03,0x75,0x01,
    0x05,0x08,0x19,0x01,0x29,0x03,0x91,0x02,
    0x95,0x05,0x75,0x01,0x91,0x01,0x95,0x06,
    0x75,0x08,0x26,0xFF,0x00,0x05,0x07,0x19,
    0x00,0x29,0x91,0x81,0x00,0xC0
}; 

/******************************************************************************/
/* USBԶHID(,Ƶ) */
UINT8C MyDevice_HID_RP_Desc[ ] =
{
    /* ÿеһֽΪĿǰ׺ */
    /* 7-4:bTag  3-2:bType(ȫֲ֡) 1-0:bSize(0 1 2 4) */
    0x06, 0x00,0xff,
    0x09, 0x04,
    0xa1, 0x01,                                                   				/* Ͽʼ */
    0x15, 0x00,                                                   				/* Logical  Minimun */
    0x26, 0xff,0x00,                                              				/* Logical  Maximun */
    0x95, 64,                                                     				/* Report Counet */
    0x75, 0x08,
    0x09, 0x02,                                                   				/* Usage Page  ÷ */
    0xb1, 0x02,                                                   				/* Logical  Minimun */
    0x09, 0x02,                                                   				/* Logical  Maximun */
    0x81, 0x02,                                                   				/* Report Size */
    0x09, 0x04,                                                   				/* Report Counet */
    0x91, 0x02,                                                   				/* Output */
    0xC0    
}; 

/******************************************************************************/
/* ̶ý屨 */
UINT8C MyDevice_KB_Media1_RP_Desc[ ] =
{
    0x05, 0x01, 0x09, 0x80, 0xA1, 0x01, 0x85, 0x01,  
    0x19, 0x81, 0x29, 0x83, 0x15, 0x00, 0x25, 0x01,  
    0x95, 0x03, 0x75, 0x01, 0x81, 0x02, 0x95, 0x01,
    0x75, 0x05, 0x81, 0x01, 0xC0, 0x05, 0x0C, 0x09,   
    0x01, 0xA1, 0x01, 0x85, 0x02, 0x15, 0x00, 0x25,     
    0x01, 0x09, 0xE9, 0x09, 0xEA, 0x09, 0xE2, 0x09,       
    0xCD, 0x19, 0xB5, 0x29, 0xB8, 0x75, 0x01, 0x95,    
    0x08, 0x81, 0x02, 0x0A, 0x8A, 0x01, 0x0A, 0x21,    
    0x02, 0x0A, 0x2A, 0x02, 0x1A, 0x23, 0x02, 0x2A,
    0x27, 0x02, 0x81, 0x02, 0x0A, 0x83, 0x01, 0x0A,    
    0x96, 0x01, 0x0A, 0x92, 0x01, 0x0A, 0x9E, 0x01,    
    0x0A, 0x94, 0x01, 0x0A, 0x06, 0x02, 0x09, 0xB2,
    0x09, 0xB4, 0x81, 0x02, 0xC0
};

/******************************************************************************/
/* USB */
UINT8C MyDevice_CfgDesc[ ] =
{
	/*  */	
    0x09, 0x02, 0x42, 0x00, 0x02, 0x01, 0x00, 0xA0, 0x64,             			/*  */
    0x09, 0x04, 0x00, 0x00, 0x01, 0x03, 0x01, 0x01, 0x00,             			/* ӿ() */
    0x09, 0x21, 0x11, 0x01, 0x00, 0x01, 0x22, sizeof( MyDevice_KB_RP_Desc ) & 0xFF, sizeof( MyDevice_KB_RP_Desc ) >> 8,   /*  */
    0x07, 0x05, 0x81, 0x03, DEF_EP1_SIZE, 0x00, 0x0A,                 		    /* ˵ */
    0x09, 0x04, 0x01, 0x00, 0x02, 0x03, 0x00, 0x00, 0x00,             			/* ӿ(ԶHID) */
    0x09, 0x21, 0x11, 0x01, 0x00, 0x01, 0x22, sizeof( MyDevice_HID_RP_Desc ) & 0xFF, sizeof( MyDevice_HID_RP_Desc ) >> 8,  /* ԶHID */    
    0x07, 0x05, 0x83, 0x03, DEF_EP2_SIZE, 0x00, 0x0A,                        	/* ˵ */
    0x07, 0x05, 0x02, 0x03, DEF_EP2_SIZE, 0x00, 0x0A,                        	/* ˵ */
};

/*****************************************************************************************/
/* USBٶƥ */
const UINT8	My_QueDescr[ ] = { 0x0A, 0x06, 0x00, 0x02, 0xFF, 0x00, 0xFF, 0x40, 0x01, 0x00 };

/* USBȫģʽ,ٶ */
UINT8 USB_FS_OSC_DESC[ sizeof( MyDevice_CfgDesc ) ] =		
{
	0x09, 0x07,		                                                            /* ͨ */
};

/* USBģʽ,ٶ */
UINT8 USB_HS_OSC_DESC[ sizeof( MyDevice_CfgDesc ) ] =		
{
	0x09, 0x07,		                                                            /* ͨ */
};

/*****************************************************************************************/
/* ַ */
UINT8C MyDevice_StringLangID[ 4 ] =
{
	0x04,
	0x03,  								 										/* bDescriptorType */
	0x09,
	0x04
}; 

/*****************************************************************************************/
/* ַ */
UINT8C MyDevice_Vendor[ 18 ] =
{
	0x0E, 0x03, 'w', 0, 'c', 0, 'h', 0, '.', 0, 'c', 0, 'n', 0
};

/*****************************************************************************************/
/* Ʒַ */
UINT8C MyDevice_StringProduct[ 36 ] =
{
	0x1A, 0x03, 'C', 0, 'H', 0, '5', 0, '5', 0, '5', 0, '_', 0, 'U', 0, 'S', 0, 'B', 0, '_', 0, 'K', 0, 'B', 0
};

/*****************************************************************************************/
/* кַ */
UINT8C MyDevice_StringSerial[ 18 ] =
{
	18,           						 										/* bLength */
	0x03,  								 										/* bDescriptorType */

	/* Manufacturer: "2021xxxx" */
	'2', 0, '0', 0, '2', 0, '1', 0, '0', 0, '4', 0, '2', 0, '7', 0    
};


#ifdef __cplusplus
}
#endif

#endif 
