/********************************** (C) COPYRIGHT *******************************
* File Name          : USB_DEVICE.C
* Author             : MJX
* Version            : V1.00
* Date               : 2021/04/29
* Description        : USB豸ײغ
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include "MAIN.H"	 															/* ͷļ */
#include "USB_DESC.H"															/* USB豸ͷļ */

/******************************************************************************/
/*  */
volatile UINT8	D0SetupReqCode = 0xFF;											/* USB Setup */
volatile UINT16	D0SetupLen = 0x00;												/* USB Setup */
volatile PUINT8	pD0Descr;
volatile UINT8  D0UsbConfig = 0x00;												/* USBñ־ */
volatile UINT8  Report_Value = 0x00;
volatile UINT8  Idle_Value = 0x00;

volatile UINT8  USB_EnumStatus = 0x00;											/* USBö״̬ */	
volatile UINT8  USB_SleepStatus = 0x00;											/* USB˯״̬ */		
volatile UINT8  MCU_Sleep_Operate = 0x00;										/* MCU˯߲־ */
   
volatile UINT8	USB_User_CMD = 0x00;											/* USBͨԶ */
UINT8X	USB_RGBData_Buf[ 144 * 4 ] = { 0 };										/* USBRGB */
UINT16X USB_RGBData_Offset = 0x00;												/* USBRGBƫ */

/*******************************************************************************
* Function Name  : USB_Device_Init
* Description    : CH55X USB豸ʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void USB_Device_Init( void )  
{
	/* ʼر */
	D0SetupReqCode = 0xFF;														/* USB Setup */
	D0SetupLen = 0x00;															/* USB Setup */
	D0UsbConfig = 0x00;															/* USBñ־ */
	USB_EnumStatus = 0x00;														/* USBö״̬ */	
	USB_SleepStatus = 0x00;														/* USB˯״̬ */		
	MCU_Sleep_Operate = 0x00;													/* MCU˯߲־ */
	KB_USB_UpStatus = 0x00;														/* USBϴ״̬ */
	KB_USB_SetReport = 0x00;													/* USBSetReportֵ */  

	/* ʼUSBؼĴ */
	IE_USB = 0;
	IP_EX &= ~bIP_USB;
    
	SAFE_MOD = 0x55;
	SAFE_MOD = 0xAA;
	GLOBAL_CFG |= bXIR_XSFR;                         
	USB_CTRL = 0;
//	D0_EP0RES = UEP_R_RES_ACK | UEP_T_RES_NAK;
//	D0_EP1RES = bUEP_X_AUTO_TOG | UEP_X_RES_NAK;
//	D0_EP2RES = bUEP_X_AUTO_TOG | UEP_X_RES_ACK;
//	D0_EP3RES = bUEP_X_AUTO_TOG | UEP_X_RES_NAK;
    
	D0_EP_MOD = bUX_EP2O_EN | bUX_DEV_EN; 
	D0_ADDR = 0;
	HB_ADDR = 0x7F;             												/* øõַ,յֱתD0 */
	USB_IF = 0xFF;
	USB_IE = bUX_IE_SUSPEND | bUX_IE_TRANSFER | bUX_IE_BUS_RST;
	USB_CTRL = bUX_DP_PU_EN; 
	IE_USB = 1;
}

/*******************************************************************************
* Function Name  : USB_DeviceInterrupt
* Description    : CH55X USB豸жϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void USB_DeviceInterrupt( void ) interrupt INT_NO_USB using 1
{
    UINT8  us,i;
	UINT16 len;

USB_DevIntNext:
	us = USB_IF; 
	if( us & bUX_IF_D0_TRANS )            
	{
		/* D0ݴ */
		switch( D0_STATUS & ( bUXS_SETUP_ACT | MASK_UXS_TOKEN | MASK_UXS_ENDP ) )     
		{
			/* ƺͶ˵ */
			case UXS_TOKEN_IN | 0:                       
			case bUXS_SETUP_ACT | UXS_TOKEN_IN | 0:
            	/* endpoint 0# IN */
				switch( D0SetupReqCode ) 
				{
					case USB_GET_DESCRIPTOR:
						len = D0SetupLen >= DEF_ENDP0_SIZE ? DEF_ENDP0_SIZE : D0SetupLen;  /* δ䳤 */
						memcpy( pD0_EP0_BUF, pD0Descr, len );  					/* ϴ */
						D0SetupLen -= len;
						pD0Descr += len;
						D0_EP0T_L = len;
						D0_EP0RES ^= bUEP_T_TOG;  								/* ת */
						break;
						
					case USB_SET_ADDRESS:
						D0_ADDR = D0SetupLen;
						D0_EP0RES = UEP_R_RES_ACK | UEP_T_RES_NAK;
						break;

					case USB_SET_FEATURE:
						break;

					default:
						/* ״̬׶жϻǿϴ0ݰƴ */
						D0_EP0T_L = 0;  
						D0_EP0RES = UEP_R_RES_ACK | UEP_T_RES_NAK;
						break;
				}
                break;

			case UXS_TOKEN_OUT | 2:  
			case bUXS_SETUP_ACT | UXS_TOKEN_OUT | 2:
				/*  endpoint 2# ˵´ */
				if( D0_STATUS & bUXS_TOG_OK ) 
				{  
					/* ͬݰ */
					len = D0_RX_LEN;
					if( ( ( pUSB_BUF_DEV0 + UX_EP2_ADDR )[ 0 ] == DEF_PACK_HEAD1 ) && 
						( ( pUSB_BUF_DEV0 + UX_EP2_ADDR )[ 1 ] == DEF_PACK_HEAD2 ) )
					{
						USB_User_CMD = ( pUSB_BUF_DEV0 + UX_EP2_ADDR )[ 2 ];
						switch( USB_User_CMD )
						{
                            case DEF_CMD_GET_RGBMODEL:
                                 memset( pUSB_BUF_DEV0 + UX_EP3_ADDR, 0, 64 );
                                ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 0 ] = DEF_PACK_HEAD1; 
                                ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 1 ] = DEF_PACK_HEAD2;
                                ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 2 ] = RGB_Mode;
                                
                                D0_EP3T_L = len;
								D0_EP2RES ^= bUEP_X_TOG;
                                D0_EP3RES = D0_EP3RES & ~MASK_UEP_X_RES | UEP_X_RES_ACK; 
                                break;
                                
                            case DEF_CMD_SET_RGBMODEL:                                  
                                RGB_Mode =( pUSB_BUF_DEV0 + UX_EP2_ADDR )[ 4 ];
                                LED_GRE_ADJ = 0;
                                 memset( pUSB_BUF_DEV0 + UX_EP3_ADDR, 0, 64 );
                                ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 0 ] = DEF_PACK_HEAD1; 
                                ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 1 ] = DEF_PACK_HEAD2;
                                ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 2 ] = RGB_Mode;
                                
                                D0_EP3T_L = len;
								D0_EP2RES ^= bUEP_X_TOG;
                                D0_EP3RES = D0_EP3RES & ~MASK_UEP_X_RES | UEP_X_RES_ACK; 
                                break;
                                
                            case DEF_CMD_GET_RGBDATA: 
                                USB_RGBData_Offset = 56;                                    
                                memset( pUSB_BUF_DEV0 + UX_EP3_ADDR, 0, 64 );
                                ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 0 ] = DEF_PACK_HEAD1; 
                                ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 1 ] = DEF_PACK_HEAD2;
                                ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 2 ] = 0xFA;
                                ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 3 ] = 0xFA;
                                ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 4 ] = USB_RGBData_Offset;
                                ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 5 ] = USB_RGBData_Offset >> 8;
                                ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 6 ] = 0;
                                ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 7 ] = 0;
                                memcpy( &( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 8 ], USB_RGBData_Buf, USB_RGBData_Offset );
                               
                                D0_EP3T_L = len;
								D0_EP2RES ^= bUEP_X_TOG;
                                D0_EP3RES = D0_EP3RES & ~MASK_UEP_X_RES | UEP_X_RES_ACK; 
                                break;
                                
                            case DEF_CMD_SET_RGBDATA:
                                i = ( pUSB_BUF_DEV0 + UX_EP2_ADDR )[ 4 ];
                                memcpy( USB_RGBData_Buf + USB_RGBData_Offset, &( pUSB_BUF_DEV0 + UX_EP2_ADDR )[ 8 ], i );
                                USB_RGBData_Offset += i;
                                memset( pUSB_BUF_DEV0 + UX_EP3_ADDR, 0, 64 );
                                ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 0 ] = DEF_PACK_HEAD1; 
                                ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 1 ] = DEF_PACK_HEAD2;
                                ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 2 ] = 0xFA; 
                                ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 3 ] = 0xFA;
                                ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 4 ] = USB_RGBData_Offset;
                                ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 5 ] = USB_RGBData_Offset >> 8;
                                
                                D0_EP3T_L = len;
								D0_EP2RES ^= bUEP_X_TOG;
                                D0_EP3RES = D0_EP3RES & ~MASK_UEP_X_RES | UEP_X_RES_ACK; 
                                break;
                                
                            default:
                            	break;
						}
					}
				}
                break; 
                          
            case UXS_TOKEN_IN | 3:  
            case bUXS_SETUP_ACT | UXS_TOKEN_IN | 3:
				/* endpoint 3# ˵ϴ */            	
				D0_EP3RES = D0_EP3RES & ~MASK_UEP_X_RES | UEP_X_RES_NAK; 		/* ͣϴ */
				if( USB_User_CMD == DEF_CMD_GET_RGBDATA )
				{
					if( USB_RGBData_Offset >= 144 * 4 ) 
					{
                        USB_RGBData_Offset = 0;
                        break;
                    }
                    i = ( 144 * 4 - USB_RGBData_Offset ) >= 56 ? 56 : ( 144 * 4 - USB_RGBData_Offset );
					memset( pUSB_BUF_DEV0 + UX_EP3_ADDR, 0, 64 );
					( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 0 ] = DEF_PACK_HEAD1; 
                    ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 1 ] = DEF_PACK_HEAD2;
                    ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 2 ] = 0xFA;
                    ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 3 ] = 0xFA;                    
                    ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 4 ] = i;
                    ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 5 ] = 0;
                    ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 6 ] = USB_RGBData_Offset;
                    ( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 7 ] = USB_RGBData_Offset >> 8;                    
                    memcpy( &( pUSB_BUF_DEV0 + UX_EP3_ADDR )[ 8 ], USB_RGBData_Buf + USB_RGBData_Offset, i );
					USB_RGBData_Offset += i;
					D0_EP3RES ^= bUEP_X_TOG;
                    D0_EP3T_L = len;
                    D0_EP3RES = D0_EP3RES & ~MASK_UEP_X_RES | UEP_X_RES_ACK; 	/* ϴ */
                }                
                break;
                
            case UXS_TOKEN_IN | 1:  
            case bUXS_SETUP_ACT | UXS_TOKEN_IN | 1:
            	/* endpoint 1# ˵ϴ */
                D0_EP1RES = D0_EP1RES & ~MASK_UEP_X_RES | UEP_X_RES_NAK; 		/* ͣϴ */
				KB_USB_UpStatus = 0x01;
                break;
               
			case UXS_TOKEN_OUT | 0:  
            case bUXS_SETUP_ACT | UXS_TOKEN_OUT | 0:
 				/* endpoint 0# OUT */
				switch( D0SetupReqCode ) 
				{
					case HID_SET_REPORT: 
						KB_USB_SetReport = pD0_EP0_BUF[ 0 ];
						D0_EP0RES ^= bUEP_R_TOG;                      
                        break;
                        
					case USB_GET_DESCRIPTOR:
					
					default:
						D0_EP0RES = UEP_R_RES_ACK | UEP_T_RES_NAK;  
						break;
				}
                break;
			
			default:
//			case bUXS_SETUP_ACT | UXS_TOKEN_FREE | 0:    
//            case bUXS_SETUP_ACT | UXS_TOKEN_FREE | 1:    
//            case bUXS_SETUP_ACT | UXS_TOKEN_FREE | 2:    
//            case bUXS_SETUP_ACT | UXS_TOKEN_FREE | 3:    
//            case bUXS_SETUP_ACT | UXS_TOKEN_FREE | 4:    
//            case bUXS_SETUP_ACT | UXS_TOKEN_FREE | 5:    
//            case bUXS_SETUP_ACT | UXS_TOKEN_FREE | 6:    
//            case bUXS_SETUP_ACT | UXS_TOKEN_FREE | 7:  
				if(( D0_STATUS & ( bUXS_SETUP_ACT | MASK_UXS_TOKEN ) ) == ( bUXS_SETUP_ACT | UXS_TOKEN_FREE ))
				{
					/* endpoint 0# SETUP */
					D0_EP0RES = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;

					len = 0;  														/* ĬΪɹϴ0 */               
					D0SetupLen = pD0_SETUP_REQ->wLengthL + ( (UINT16)pD0_SETUP_REQ->wLengthH << 8 );
					D0SetupReqCode = pD0_SETUP_REQ->bRequest;
					
					/* ǰSetup */				                
					if( ( pD0_SETUP_REQ->bRequestType & USB_REQ_TYP_MASK ) == USB_REQ_TYP_STANDARD )
					{ 
						/* ׼ */                                   
						switch( D0SetupReqCode ) 
						{  
							case USB_GET_DESCRIPTOR:            
								/* ȡUSB */
								switch( pD0_SETUP_REQ->wValueH )
								{
									case USB_DESCR_TYP_DEVICE:  
										/* USB豸 */
										pD0Descr = (PUINT8)( &MyDevice_DevDesc[ 0 ] );
										len = sizeof( MyDevice_DevDesc );
										break;
										
									case USB_DESCR_TYP_CONFIG:  
										/* USB */
										pD0Descr = (PUINT8)( &MyDevice_CfgDesc[ 0 ] );
										len = sizeof( MyDevice_CfgDesc );
										break;
										
									case USB_DESCR_TYP_STRING:  
										/* USBַ */
										switch( pD0_SETUP_REQ->wValueL ) 
										{
											case 1:
												pD0Descr = (PUINT8)( &MyDevice_Vendor[ 0 ] );
												len = sizeof( MyDevice_Vendor );
												break;
																			
											case 2:
												pD0Descr = (PUINT8)( &MyDevice_StringProduct[ 0 ] );
												len = sizeof( MyDevice_StringProduct );
												break;
												
											case 0:
												pD0Descr = (PUINT8)( &MyDevice_StringLangID[ 0 ] );
												len = sizeof( MyDevice_StringLangID );
												break;
												
											default:
												/* ֵַ֧ */
												len = 0xFFFF;  
											break;
										}
										break;

									case USB_DESCR_TYP_HID:
										switch( pD0_SETUP_REQ->wIndexL )
										{       
											/* ѡӿ */
											case 0:
												pD0Descr = (PUINT8)( &MyDevice_CfgDesc[ 18 ] );        
												len = 9;
												break;										
											
											case 1:
												pD0Descr = (PUINT8)( &MyDevice_CfgDesc[ 43 ] );    
												len = 9;
												break;			
												
											default:
												/* ֵַ֧ */
												len = 0xFFFF;  
												break;
										}
										break;

									case USB_DESCR_TYP_REPORT:  
										/* HID */
										switch( pD0_SETUP_REQ->wIndexL )
										{       
											/* ѡӿ */
											case 0:
												pD0Descr = (PUINT8)( &MyDevice_KB_RP_Desc[ 0 ] );        
												len = sizeof( MyDevice_KB_RP_Desc );
												break;										
											
											case 1:
												pD0Descr = (PUINT8)( &MyDevice_HID_RP_Desc[ 0 ] );    
												len = sizeof( MyDevice_HID_RP_Desc );
												break;			
												
											default:
												/* ֵַ֧ */
												len = 0xFFFF;  
												break;
										}
										break;
										
									case 0x06:
										pD0Descr = (PUINT8)( &My_QueDescr[ 0 ] );    								   
										len = sizeof( My_QueDescr );
										break;
											
									case 0x07:	
										memcpy( &USB_FS_OSC_DESC[ 2 ], &MyDevice_CfgDesc[ 2 ], sizeof( MyDevice_CfgDesc ) - 2 );
										pD0Descr = (PUINT8)( &USB_FS_OSC_DESC[ 0 ] );    
										len = sizeof( USB_FS_OSC_DESC );
										break;
										
									default:
										/* ֵַ֧ */
										len = 0xFFFF; 
										break;
								}

								/* жǷ */								
								if( len != 0xFFFF )
								{
									if( D0SetupLen > len ) 
									{	
										D0SetupLen = len;  							/* ܳ */
									}
									len = D0SetupLen >= DEF_ENDP0_SIZE ? DEF_ENDP0_SIZE : D0SetupLen;  /* δ䳤 */
									D0SetupLen -= len;
									memcpy( pD0_EP0_BUF, pD0Descr, len );  			/* ϴ */
									pD0Descr += len;
								}
								break;
								
							case USB_SET_ADDRESS:               
								/* USB豸ַ */
								D0SetupLen = pD0_SETUP_REQ->wValueL;  				/* ݴUSB豸ַ */
								break;
								
							case USB_GET_CONFIGURATION:
								pD0_EP0_BUF[ 0 ] = D0UsbConfig;
								if( D0SetupLen >= 1 ) 
								{
									len = 1;
								}
								break; 
														
							case USB_SET_CONFIGURATION:
								D0UsbConfig = pD0_SETUP_REQ->wValueL;
								USB_EnumStatus = 0x01;
								KB_USB_UpStatus = 0x01;
								break;			
																
							case USB_SET_FEATURE:
								if( ( pD0_SETUP_REQ->bRequestType & USB_REQ_RECIP_MASK ) == USB_REQ_RECIP_ENDP ) 
								{  
									/* ˵ */
									switch( pD0_SETUP_REQ->wIndexL ) 
									{
										case 0x83:
										case 0x03:
											D0_EP3RES = D0_EP3RES & ~( MASK_UEP_X_RES ) | UEP_X_RES_STALL;
											break;
											
										case 0x82:
										case 0x02:
											D0_EP2RES = D0_EP2RES & ~( MASK_UEP_X_RES ) | UEP_X_RES_STALL;
											break;
											
										case 0x81:
										case 0x01:
											D0_EP1RES = D0_EP1RES & ~( MASK_UEP_X_RES ) | UEP_X_RES_STALL;
											break;
											
										default:
											/* ֵ֧Ķ˵ */
											len = 0xFFFF;  
											break;
									}
								}
								else if( ( pD0_SETUP_REQ->bRequestType & USB_REQ_RECIP_MASK ) == USB_REQ_RECIP_DEVICE )
								{
									if( pD0_SETUP_REQ->wValueL == 1 )
									{ 
										/* ˯ */
										USB_SleepStatus |= 0x01; 
									}		
								}
								else
								{
									len = 0xFFFF;
								}															
								break;
													
							case USB_SET_INTERFACE:
								break;
								
							case USB_CLEAR_FEATURE:
								if( ( pD0_SETUP_REQ->bRequestType & USB_REQ_RECIP_MASK ) == USB_REQ_RECIP_ENDP ) 
								{  
									/* ˵ */
									switch( pD0_SETUP_REQ->wIndexL ) 
									{
										case 0x83:
											D0_EP3RES = D0_EP3RES & ~(  MASK_UEP_X_RES ) | UEP_X_RES_NAK;
											break;
											
										case 0x03:
											D0_EP3RES = D0_EP3RES & ~(  MASK_UEP_X_RES ) | UEP_X_RES_ACK;
											break; 
																  
										case 0x82:                       
											D0_EP2RES = D0_EP2RES & ~(  MASK_UEP_X_RES ) | UEP_X_RES_NAK;
											break;   
																
										case 0x02:                       
											D0_EP2RES = D0_EP2RES & ~(  MASK_UEP_X_RES ) | UEP_X_RES_ACK;
											break; 
																  
										case 0x81:                       
											D0_EP1RES = D0_EP1RES & ~(  MASK_UEP_X_RES ) | UEP_X_RES_NAK;
											break;
																   
										case 0x01:                       
											D0_EP1RES = D0_EP1RES & ~(  MASK_UEP_X_RES ) | UEP_X_RES_ACK;
											break;
											
										default:
											len = 0xFFFF;  
											break;
									}
								}
								else if( ( pD0_SETUP_REQ->bRequestType & USB_REQ_RECIP_MASK ) == USB_REQ_RECIP_DEVICE )
								{
									if( pD0_SETUP_REQ->wValueL == 1 )
									{ 
										USB_SleepStatus &= ~0x01;                      
									}
								}
								else
								{
									len = 0xFFFF;  
								}											
								break;
												
							case USB_GET_INTERFACE:
								pD0_EP0_BUF[ 0 ] = 0x00;
								if( D0SetupLen >= 1 ) 
								{
									len = 1;
								}
								break;
								
							case USB_GET_STATUS: 
								if( ( pD0_SETUP_REQ->bRequestType & USB_REQ_RECIP_MASK ) == USB_REQ_RECIP_ENDP ) 
								{  
									/* ˵ */
									pD0_EP0_BUF[ 0 ] = 0x00;
									switch( pD0_SETUP_REQ->wIndexL ) 
									{
										case 0x83:                                       
										case 0x03:
											if( ( D0_EP3RES & MASK_UEP_X_RES ) == UEP_X_RES_STALL )
											{
												pD0_EP0_BUF[ 0 ] = 0x01;
											}                                      
											break;
											
										case 0x82:                                     
										case 0x02:
											if( ( D0_EP2RES & MASK_UEP_X_RES ) == UEP_X_RES_STALL )
											{
												pD0_EP0_BUF[ 0 ] = 0x01;																					
											}
											break;
											
										case 0x81:                                       
										case 0x01:
											if( ( D0_EP1RES &MASK_UEP_X_RES ) == UEP_X_RES_STALL )
											{
												pD0_EP0_BUF[0] = 0x01;
											}
											break;                                
										}
								}
								else if( ( pD0_SETUP_REQ->bRequestType & USB_REQ_RECIP_MASK ) == USB_REQ_RECIP_DEVICE )
								{
									pD0_EP0_BUF[ 0 ] = 0x00;
									if( USB_SleepStatus )
									{
										pD0_EP0_BUF[ 0 ] = 0x02;
									}
									else
									{
										pD0_EP0_BUF[0] = 0x00;
									}
								}																	
								pD0_EP0_BUF[ 1 ] = 0;
								if( D0SetupLen >= 2 ) 
								{
									len = 2;
								}
								else 
								{
									len = D0SetupLen;
								}
								break;
								
							default:
								/* ʧ */
								len = 0xFFFF;  
								break;
						}
					}
					else if( ( pD0_SETUP_REQ->bRequestType & USB_REQ_TYP_MASK ) != USB_REQ_TYP_STANDARD ) 
					{  
						/* Ǳ׼ */
						
						/* ,󣬲 */	
						if( pD0_SETUP_REQ->bRequestType & 0x40 )		 		
						{    
							/*  */
						}		
						else if( pD0_SETUP_REQ->bRequestType & 0x20 )	 		
						{
							/*  */
							switch( D0SetupReqCode )
							{
								case DEF_USB_SET_REPORT:			 				/* 0x09: SET_REPORT */
									break;
								
								case DEF_USB_SET_IDLE:								/* 0x0A: SET_IDLE */
									Idle_Value = pD0_EP0_BUF[ 3 ];
									break;
									
								case DEF_USB_SET_PROTOCOL:							/* 0x0B: SET_PROTOCOL */
									Report_Value = pD0_EP0_BUF[ 2 ];
									break;
									
								case DEF_USB_GET_IDLE:								/* 0x02: GET_IDLE */
									pD0_EP0_BUF[ 0 ] = Idle_Value;
									len = 1;
									break;

								case DEF_USB_GET_PROTOCOL:							/* 0x03: GET_PROTOCOL */
									pD0_EP0_BUF[ 0 ] = Report_Value;
									len = 1;
									break;
									
								default:
									len = 0xFFFF;  							
									break;
							}
						}
					}
					else
					{  
						/* ֱֻ֧׼/ */
						len = 0xFFFF;  
					}
					
					if( len == 0xFFFF ) 
					{  
						/* ʧ */
						D0SetupReqCode = 0xFF;
						D0_EP0RES = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_STALL | UEP_T_RES_STALL;  
						
						/* ʱSTALL,ֹһSETUP */					
						i = 255;
						while( i-- );
						D0_EP0RES = D0_EP0RES & ~(MASK_UEP_R_RES|MASK_UEP_T_RES) | UEP_R_RES_ACK | UEP_T_RES_NAK;	
					}
					else if( len <= DEF_ENDP0_SIZE ) 
					{  
						/* ϴݻ״̬׶η0Ȱ */               
						D0_EP0T_L = len;
						D0_EP0RES = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;  /* ĬݰDATA1 */  
					}
					else 
					{  
						/* ´ݻ */
						/* Ȼδ״̬׶,ǰԤϴ0ݰԷǰ״̬׶ */
						D0_EP0T_L = 0;  
						D0_EP0RES = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;  /* ĬݰDATA1 */
					}
				}
				break;
		}     
        D0_STATUS = 0;    
	}
	else if( us & bUX_IF_SUSPEND )
    {
    	/* ߻¼ */	
		if( us & bUX_SUSPEND )
		{       
			/* ¼ */
#if( DEF_DEBUG_PRINTF == 0x01 )
        printf("zzz...\n");
#endif   	
			USB_SleepStatus |= 0x02;			
			if( USB_SleepStatus != 0x03 )
			{				
				USB_EnumStatus = 0x00;									
			}
			else
			{
				MCU_Sleep_Operate = 0x01;
			}
		}
		else
		{                      
			/* ¼ */
			USB_SleepStatus &= ~0x02;
			USB_EnumStatus = 0x01;										
        }
		USB_IF = bUX_IF_SUSPEND;
		D0_STATUS = 0;
    }
	else if(us & bUX_IF_BUS_RST) 
    {
    	/*߸λ¼*/
#if( DEF_DEBUG_PRINTF == 0x01 )
        printf("reset...\n");
#endif 
        D0_EP0RES = UEP_R_RES_ACK | UEP_T_RES_NAK;
        D0_EP1RES = UEP_X_RES_NAK;
       	D0_EP2RES = UEP_X_RES_ACK;
        D0_EP3RES = UEP_X_RES_NAK; 
        D0_EP_MOD = bUX_EP2O_EN | bUX_DEV_EN;  
        D0_ADDR = 0;
        HB_ADDR = 0x7F;             
        USB_IF = 0xFF;
        
        USB_IE = bUX_IE_SUSPEND | bUX_IE_TRANSFER | bUX_IE_BUS_RST;

        KB_USB_UpStatus = 0x00;

        USB_IF = bUX_IF_BUS_RST;
	}
	else
    {
    	/*ǲҪжϣֱ*/
#if( DEF_DEBUG_PRINTF == 0x01 )
        printf("@@@\n");
#endif
        D0_STATUS = 0;
	}
  	
  	/* ٴжǷUSBжҪ */
	if( USB_IF & ( bUX_IF_D0_TRANS | bUX_IF_SUSPEND | bUX_IF_BUS_RST ) ) 
	{
		goto USB_DevIntNext;
	}    
}

/*******************************************************************************
* Function Name  : USB_WakeUp_PC
* Description    : USB豸Ѽ
* Input          : None
* Output         : None
* Return         : None									   
*******************************************************************************/
void USB_WakeUp_PC( void )
{
	UINT8  save;
	
	save = USB_CTRL;
    USB_CTRL ^= bUX_DP_PU_EN | bUX_DM_PU_EN;
    mDelaymS( 10 );  
    USB_CTRL = save;
}

/*******************************************************************************
* Function Name  : CH55X_Sleep_Deal
* Description    : CH55XƬ˯ߴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void CH55X_Sleep_Deal( void )	
{
	UINT8	savePortCfg;

	P4_LED_KEY = 0xFF;															/* enable key mode */
    P4_MOD_OC = 0xFF;															/* disable push-pull output */
    LED_CTRL &= ~bLED_EN;
																				/* P4_DIR_PU = 0xFF; */																						
	P0 = P3 = 0;																/* COMMON all low to support any key wakeup */
																				/* P7 &= ~ 0x03, if P7 used for COMMON  */ 
	savePortCfg = PORT_CFG;
	PORT_CFG |= bP4_IE_LEVEL;		/* enable P4 level change to wakeup, P4 input@pullup vs P4 output@0xFF, so low action */
																				/* USB_CTRL = 0; */	
	/* ˯ǰUSBл7K5 */
	P6_OUT_PU = ( 1 << 1 );
	USB_CTRL &= ~bUX_DP_PU_EN;
	P6_DIR = 0;
	
	PCON |= PD;																	/* sleep */
		
	mDelaymS( 1 ); 
	USB_CTRL |= bUX_DP_PU_EN;
	P6_OUT_PU = 0;

	SAFE_MOD = 0x55;
	SAFE_MOD = 0xAA;
	WAKE_CTRL = 0x00;
	SAFE_MOD = 0x00;
    
	PORT_CFG = savePortCfg;
	if ( GPIO_IE & bIE_IO_EDGE ) 
	{	
		/* edge mode interrupt */
		GPIO_IE &= ~ bIE_IO_EDGE;												/* clear P4 level change interrupt flag */
		GPIO_IE |= bIE_IO_EDGE;	
	}
	mDelaymS( 5 );

	P0 = P3 = 0xFF;  																							
	LED_CTRL = bLED_IE_INHIB | bLED_BLUE_EN | bLED_GREEN_EN | bLED_RED_EN | bLED_COM_AHEAD | bLED_PWM_INHIB | bLED_EN;
	LED_STATUS |= bLED_IF_SET;  												/* force bLED_IF to enter interrupt service */
	IE_PWM_I2C = 1;   
}

