/********************************** (C) COPYRIGHT *******************************
* File Name          : DEVICE.H
* Author             : MJX
* Version            : V1.00
* Date               : 2021/04/29
* Description        : CH55X USB豸ض
*******************************************************************************/



#ifndef __DEVICE_H__
#define __DEVICE_H__

#ifdef __cplusplus
extern "C" {
#endif

/******************************************************************************/
/* ͷļ */
#include "MAIN.H"	 															/* ͷļ */

/***********************************************************************************************************************/
/* USB豸غ궨 */
#define bUEP_R_TOG        0x80      // expected data toggle flag of USB endpoint X receiving (OUT): 0=DATA0, 1=DATA1
#define bUEP_T_TOG        0x40      // prepared data toggle flag of USB endpoint X transmittal (IN): 0=DATA0, 1=DATA1
#define bUEP_R_RES1       0x08      // handshake response type high bit for USB endpoint X receiving (OUT)
#define bUEP_R_RES0       0x04      // handshake response type low bit for USB endpoint X receiving (OUT)
#define MASK_UEP_R_RES    0x0C      // bit mask of handshake response type for USB endpoint X receiving (OUT)
#define UEP_R_RES_ACK     0x00
#define UEP_R_RES_TOUT    0x04
#define UEP_R_RES_NAK     0x08
#define UEP_R_RES_STALL   0x0C
// bUEP_R_RES1 & bUEP_R_RES0: handshake response type for USB endpoint X receiving (OUT)
//   00: ACK (ready)
//   01: no response, time out to host, for non-zero endpoint isochronous transactions
//   10: NAK (busy)
//   11: STALL (error)

#define bUEP_T_RES1       0x02      // handshake response type high bit for USB endpoint X transmittal (IN)
#define bUEP_T_RES0       0x01      // handshake response type low bit for USB endpoint X transmittal (IN)
#define MASK_UEP_T_RES    0x03      // bit mask of handshake response type for USB endpoint X transmittal (IN)
#define UEP_T_RES_ACK     0x00
#define UEP_T_RES_TOUT    0x01
#define UEP_T_RES_NAK     0x02
#define UEP_T_RES_STALL   0x03
// bUEP_T_RES1 & bUEP_T_RES0: handshake response type for USB endpoint X transmittal (IN)
//   00: DATA0 or DATA1 then expecting ACK (ready)
//   01: DATA0 or DATA1 then expecting no response, time out from host, for non-zero endpoint isochronous transactions
//   10: NAK (busy)
//   11: STALL (error)


/************************************************/ 
/* ˵Сȶ */
#define DEF_ENDP0_SIZE             DEFAULT_ENDP0_SIZE
#define DEF_EP1_SIZE               DEFAULT_ENDP0_SIZE                           /* ̶˵ݰС */
#define DEF_EP2_SIZE               64 

/************************************************/
/* HID */ 
#define DEF_USB_GET_IDLE           0x02           								/* get idle for key or mouse */
#define DEF_USB_GET_PROTOCOL       0x03          								/* get protocol for bios type */
#define DEF_USB_SET_REPORT         0x09           								/* set report for key */
#define DEF_USB_SET_IDLE           0x0A           								/* set idle for key or mouse */
#define DEF_USB_SET_PROTOCOL       0x0B           								/* set protocol for bios type */

/*******************************************************************************/
/* ʹغ궨 */
#define DEF_PACK_HEAD1		   	   0x57		  									/* ͷֽ1 */
#define DEF_PACK_HEAD2		       0xAB 										/* ͷֽ2 */

#define DEF_CMD_GET_RGBMODEL       0x01
#define DEF_CMD_SET_RGBMODEL       0x02  
#define DEF_CMD_GET_RGBDATA        0x03
#define DEF_CMD_SET_RGBDATA        0x04     

typedef struct				//λ
{
	UINT8 first;		
	UINT8 second;	    
	UINT8 cmd1;		    
	UINT8 cmd2;		    
    UINT8 cou1;		
	UINT8 cou2;		
	UINT8 len1;		    
	UINT8 len2;		
    UINT8 dat[56];
}HID_VALUE;  

#define pHID_VALUE     ((HID_VALUE *)pUSB_BUF_DEV0+UX_EP2_ADDR)    
void	InitUSB_Device( void );

/***********************************************************************************************************************/
/*  */
extern UINT8X MyDevice_DevDesc[ ];												/* USB豸 */
extern UINT8C MyDevice_CfgDesc[ ];												/* USB */
extern UINT8C MyDevice_KB_RP_Desc[ ];											/* USḆ */
extern UINT8C MyDevice_HID_RP_Desc[ ];											/* USBԶHID */
extern UINT8C MyDevice_Media1_RP_Desc[ ];										/* ̶ý1 */					
extern UINT8C MyDevice_StringLangID[ ];											/* ַ */
extern UINT8C MyDevice_StringProduct[ ];										/* Ʒַ */
extern UINT8C MyDevice_StringSerial[ ];											/* кַ */

extern volatile UINT8  D0SetupReqCode;											/* USB Setup */
extern volatile UINT16 D0SetupLen;												/* USB Setup */
extern volatile PUINT8 pD0Descr;
extern volatile UINT8  D0UsbConfig;												/* USBñ־ */

extern volatile UINT8  USB_EnumStatus;											/* USBö״̬ */	
extern volatile UINT8  USB_SleepStatus;											/* USB˯״̬ */	
extern volatile UINT8  MCU_Sleep_Operate;										/* MCU˯߲־ */	

/***********************************************************************************************************************/
/*  */
extern void USB_Device_Init( void );											/* CH55X USB豸ʼ */
extern void USB_WakeUp_PC( void );												/* CH55X USB豸Ѽ */	
extern void CH55X_Sleep_Deal( void );											/* CH55XƬ˯ߴ */

#ifdef __cplusplus
}
#endif

#endif

/***********************************************************************************************************************/


